/* rabbit.cpp
 *
 * K*A*I*L*A
 */

#include <iostream>
#include <string>
#include <cstdlib>
#include <cctype>
#include <ctime>
#include "socklib.h"

#include <unistd.h>

using namespace std;

int server();
int client(const char *ip, const char *host);
bool send_string(int socket, string str);
string recv_string(int socket);

string en_conv[] = {"Exeis lago?", "Exw lago", "Exei oura?", "HahahahAHhAhAHAHAhahahaha"};
string gr_conv[] = {" ;", " ", " ;", ""};
string *conv = en_conv;

int delay = 500;
int alc = 10;

const char *usage = "rabbit [options]\n"
	"options:\n"
	"  -a <num>: percentage of alcohol in the program's blood (?)\n"
	"  -i <ip>: ip address of the server\n"
	"  -n <host>: hostname of the server\n"
	"  -d <val>: delay before replying\n"
	"  -g: greek text\n"
	"  -h: this help screen\n";

#define SERVER	(!host && !ip)
#define LAUGH	conv[3]
	
int main(int argc, char *argv[])
{
	char *host = 0, *ip = 0;

	for(int i=1; i<argc; i++) {
		if(argv[i][0] == '-' && argv[i][2] == 0) {
			switch(argv[i][1]) {
			case 'i':
				if(host) {
					cerr << "you can't specify both a hostname and an IP, choose one method :)\n";
					return EXIT_FAILURE;
				}
				ip = argv[++i];
				break;

			case 'n':
				if(ip) {
					cerr << "you can't specify both a hostname and an IP, choose one method :)\n";
					return EXIT_FAILURE;
				}
				host = argv[++i];
				break;
				
			case 'd':
				if(isdigit(argv[++i][0])) {
					delay = atoi(argv[i]);
				} else {
					cerr << "-d must be followed by a number (milliseconds)\n";
					return EXIT_FAILURE;
				}
				break;

			case 'g':
				conv = gr_conv;
				break;

			case 'a':
				if(!isdigit(argv[++i][0]) || (alc = atoi(argv[i])) > 100 || alc < 0) {
					cerr << "-a must be followed by the percentage (0 - 100) of alcohol\n";
					return EXIT_FAILURE;
				}
				break;

			case 'h':
			default:
				cerr << usage << endl;
				return 0;
			}
		} else {
			cerr << "unrecognized option: " << argv[i] << endl;
			cerr << usage << endl;
			return 0;
		}
	}

	if(SERVER) {
		server();
	} else {
		client(ip, host);
	}
	
	return 0;
}

int server()
{
	int lsocket = sl_listen(1821);
	if(lsocket < 0) {
		return -1;
	}
	
	int socket = sl_accept(lsocket);
	if(socket < 0) {
		return -1;
	}

	int expect = 0;
	int iter = 0;
	for(;;) {
		string got = recv_string(socket);
		cout << iter << "\tR: " << got << endl;
		if(got != conv[expect]) {
			send_string(socket, LAUGH);
			cout << LAUGH << endl;
			break;
		}

		usleep(delay * 1000);
		
		int say;
		if(rand() % 1000 < alc * 10) {
			say = rand() % 3;
		} else {
			say = (expect + 1) % 3;
		}
		send_string(socket, conv[say]);
		cout << iter++ << "\tS: " << conv[say] << endl;
		expect = (expect + 2) % 3;
	}

	sl_close_socket(socket);
	return 0;
}

int client(const char *ip, const char *host)
{
	int socket = sl_connect_tcp(ip, host, 1821);
	if(socket < 0) {
		return -1;
	}

	int say = 0;
	int iter = 0;
	for(;;) {
		send_string(socket, conv[say]);
		cout << iter << "\tS: " << conv[say] << endl;

		int expect = (say + 1) % 3;
		string got = recv_string(socket);
		cout << iter++ << "\tR: " << got << endl;
		if(got != conv[expect]) {
			send_string(socket, LAUGH);
			cout << LAUGH << endl;
			break;
		}

		if(rand() % 1000 < alc * 10) {
			say = rand() % 3;
		} else {
			say = (say + 2) % 3;
		}

		usleep(delay * 1000);
	}

	sl_close_socket(socket);
	return 0;
}

bool send_string(int socket, string str)
{
	str += (char)0;
	if(sl_send_data(socket, str.c_str(), str.size()) != (int)str.size()) return false;
	return true;
}

string recv_string(int socket)
{
	char c;
	string str;
	for(;;) {
		sl_recv_data(socket, &c, 1);
		if(!c) break;
		str += c;
	}

	return str;
}

